<?php

namespace DMK\Mksearch\Hooks;

use DmitryDulepov\Realurl\Configuration\ConfigurationReader;

/**
 *  Copyright notice.
 *
 *  (c) Hannes Bochmann <dev@dmk-ebusiness.de>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 */

/**
 * Class RealUrlConfigurationReaderTest.
 *
 * @author  Hannes Bochmann
 * @license http://www.gnu.org/licenses/lgpl.html
 *          GNU Lesser General Public License, version 3 or later
 */
class RealUrlConfigurationReaderTest extends \tx_rnbase_tests_BaseTestCase
{
    protected function setUp()
    {
        if (!\tx_rnbase_util_Extensions::isLoaded('realurl')) {
            self::markTestSkipped('realurl not installed');
        }
    }

    /**
     * @group unit
     */
    public function testAddMksearchToBannedUrlsRegExp()
    {
        $configurationReader = $this->getMock(ConfigurationReader::class, ['dummy'], [], '', false);
        $configurationReaderHook = \tx_rnbase::makeInstance(RealUrlConfigurationReader::class);

        $parameters = [];
        $configurationReaderHook->addMksearchToBannedUrlsRegExp($parameters, $configurationReader);

        self::assertContains('tx_solr|mksearch', $parameters['configuration']['cache']['banUrlsRegExp']);
    }
}
